/***************************************************************************
 *     copyright            : (C) 2005 by Roman Szymkowiak                 *                                           *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "kontrolki.h"

#define  MAXPATH     256


static OPENFILENAME ofn1 ;
char New_File[260];          // przechowuje nazw pliku


void odczytajPlansze(char* buf1,HWND hwnd);

void PopFileInitialize (HWND hwnd)
	  {
	  static char szFilter[] = "(*.sud)\0*.sud\0"  \
	                           "(*.sdk)\0*.sdk\0"  \
	                           "(*.txt)\0*.txt\0"  \
										"wszystkie (*.*)\0*.*\0\0" ;
	  static char szBuffer[MAXPATH] ;
      New_File[0] = '\0';

	  getcwd (szBuffer, MAXPATH) ;

	  ofn1.lStructSize       = sizeof (OPENFILENAME) ;
	  ofn1.hwndOwner         = hwnd ;
	  ofn1.hInstance         = NULL ;
	  ofn1.lpstrFilter       = szFilter ;
	  ofn1.lpstrCustomFilter = NULL ;
	  ofn1.nMaxCustFilter    = 0 ;
	  ofn1.nFilterIndex      = 0 ;
	  ofn1.lpstrFile         = NULL ;          // Ustaw w funkcjach Open i Close
	  ofn1.nMaxFile          = _MAX_PATH ;
	  ofn1.lpstrFileTitle    = NULL ;          // Ustaw w funkcjach Open i Close
	  ofn1.nMaxFileTitle     = _MAX_FNAME + _MAX_EXT ;
	  ofn1.lpstrInitialDir   = szBuffer ;
	  ofn1.lpstrTitle        = NULL ;
	  ofn1.Flags             = 0 ;             // Ustaw w funkcjach Open i Close
	  ofn1.nFileOffset       = 0 ;
	  ofn1.nFileExtension    = 0 ;
	  ofn1.lpstrDefExt       = "sud" ;
	  ofn1.lCustData         = 0L ;
	  ofn1.lpfnHook          = NULL ;
	  ofn1.lpTemplateName    = NULL ;
	  }

BOOL PopFileSaveDlg (HWND hwnd, PSTR pstrFileName, PSTR pstrTitleName)
     {
      int i;
      i = strlen(pstrFileName);
      if (i >4)
      {
        if (pstrFileName[i-4]== '.') pstrFileName[i-4]='\0';
      }  
	  ofn1.hwndOwner         = hwnd ;
	  ofn1.lpstrFile         = pstrFileName ;
	  ofn1.lpstrFileTitle    = pstrTitleName ;
	  ofn1.Flags             = OFN_OVERWRITEPROMPT ;

	  return GetSaveFileName (&ofn1) ;
	  }

BOOL PopFileOpenDlg (HWND hwnd, PSTR pstrFileName, PSTR pstrTitleName)
     {
     ofn1.hwndOwner         = hwnd ;
     ofn1.lpstrFile         = pstrFileName ;
     ofn1.lpstrFileTitle    = pstrTitleName ;
     ofn1.Flags             = OFN_HIDEREADONLY | OFN_CREATEPROMPT ;

     return GetOpenFileName (&ofn1) ;
     }

//------------------------
void FileSaveClick(HWND hwnd)
{
	  char szBuffer[280] ;
	  char szBuffer1[280] ;

		szBuffer[0] = '\0';
		strcpy(szBuffer1,New_File);

		if (PopFileSaveDlg (hwnd,szBuffer1, szBuffer))
		{
		  strcpy(New_File,szBuffer);
		  
		 if (PopFileWrite (New_File))
		 {
		  
		  return ;
		  }
		 else
		  {
		 wsprintf (szBuffer, "Bd zapisu zbioru %s", New_File) ;
		 MessageBox (hwnd, szBuffer, "UWAGA", MB_OK | MB_ICONEXCLAMATION) ;
		  }
  
		  
	  }
}

//------------------------
void FileOpenClick(HWND hwnd)
{
	  char szBuffer[280] ;
	  char szBuffer1[280] ;

		szBuffer[0] = '\0';
		strcpy(szBuffer1,New_File);

	 if (PopFileOpenDlg (hwnd, szBuffer1, szBuffer))
	  {
	    odczytajPlansze(szBuffer,hwnd);
	  }
     

}
//----------------------------------
void odczytajPlansze(char* buf1,HWND hwnd)
{



		  strcpy(New_File,buf1);
		  
		  
	New_File[259] ='\0';	  
		  
		if (!PopFileRead (New_File))
		 {
		 wsprintf (buf1, "Bd odczytu zbioru %s", New_File) ;
		 MessageBox (hwnd, buf1, "UWAGA", MB_OK | MB_ICONEXCLAMATION) ;
		 return  ;
		 }
}
//----------------------------------
void odczytajPlanszeLinia(char* buf1,HWND hwnd)
{
  char szBuffer[280];
  int i,x;
  
    strcpy(szBuffer,buf1);
    
   i = strlen(szBuffer);     //wyrzucenie spacji na koncu wiersza
   i--;
   for(x=i;x>0;x--) 
   { 
    if (szBuffer[x] == ' ') { szBuffer[x] == '\0';}
    else break;
    
    }
   
   i = strlen(szBuffer);           //wyrzucenie cudzysowu
   if (szBuffer[i-1] == '"') szBuffer[i-1] = '\0';
   
   
  
   if (szBuffer[0] == '"')
   {
     for(x=0;x<i;x++) szBuffer[x] = szBuffer[x+1];
     
   } 
    
    odczytajPlansze(szBuffer,hwnd);  
     
}

