/***************************************************************************
 *     copyright            : (C) 2005 by Roman Szymkowiak                 *                                           *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <windows.h>
#include "main.h"
#include "kontrolki.h"
#include "menu.h"
#include "kolor.h"
#include "historia.h"
#include "mojedit.h"
#include "zegar.h"

char szClassLabel[ ] = "mojlabel";
 WNDCLASSEX wincllabel;   
 
 HBRUSH   hBrushLabel =0;
 COLORREF labeltlo;     //kolor ta label
 HMENU hMenuLabel ;
 
 HWND tablabel[10][10];  //tablica kontrolek label
char naplabel[10][10];  //zawartosc znaku na polu


 LRESULT CALLBACK WindowProcedureLabel (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
 void wstawlabel(HWND hwnd,char w);
 void odblokujMenu(void);
 void menuzablokuj(int x1,int y1);
 void zmienkolorlabel(COLORREF col); 
 
 int labelclassa(void)
 {
    wincllabel.hInstance = zadanie;
    wincllabel.lpszClassName = szClassLabel;
    wincllabel.lpfnWndProc = (WNDPROC) WindowProcedureLabel;     
    wincllabel.style = CS_DBLCLKS | CS_GLOBALCLASS | CS_HREDRAW | CS_VREDRAW | CS_CLASSDC		;                 /* Catch double-clicks */
    wincllabel.cbSize = sizeof (WNDCLASSEX);
    wincllabel.hIcon = NULL;
    wincllabel.hIconSm = NULL;
    wincllabel.hCursor = LoadCursor (NULL, IDC_ARROW) ;
    wincllabel.lpszMenuName = NULL;                
    wincllabel.cbClsExtra = 0;                      
    wincllabel.cbWndExtra = 0;                        
    wincllabel.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    
        if (!RegisterClassEx (&wincllabel))
        {
           MessageBox(hwndokno,"NIE MOG ZAREJESTROWA KLASY","Bd",MB_OK);
           return 0;
        }
       
     
     labeltlo = RGB(255,255,0);
  hBrushLabel = CreateSolidBrush(labeltlo);
 
  hMenuLabel = LoadMenu (zadanie, MAKEINTRESOURCE(ID_MENU_LABEL)) ;
  hMenuLabel = GetSubMenu (hMenuLabel, 0) ;

 
    return 1;     
 }
  
 //------------------------------------------   
LRESULT CALLBACK WindowProcedureLabel (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
     {
              PAINTSTRUCT  ps ;
       HDC          hdc ;
       RECT         rect;
       int x,y;
       char nap;
           POINT        point ;
       int x1,y1;    

    
      
     switch (iMsg)
          {
          
    	 case WM_RBUTTONDOWN :
        	 {
        	 
        
        	         	 
        	 odblokujMenu();
        	 
        	 
        	    for (y=1 ; y < 10; y++){
                  for (x=1 ; x<10; x++){
                   if (tablabel[x][y] == hwnd)
                    {
                       x1=x, y1 =y;         
                      break;
                    } 
                   }
                  }      
 
        	 if (IsWindowEnabled(tabedit[x1][y1]))
        	 {
        	   menuzablokuj(x1,y1);
        	 
               point.x = LOWORD (lParam) ;
               point.y = HIWORD (lParam) ;
               ClientToScreen (hwnd, &point) ;

               TrackPopupMenu (hMenuLabel, 0, point.x, point.y, 0, hwnd, NULL) ;
              }
      	 
        	 
        	 
              return 0;
             }
         case WM_COMMAND :
                switch (LOWORD (wParam))
                    {
                    case IDM_CYFRA0 :
                       wstawlabel(hwnd,' ');
                       return 0 ;
                    case IDM_CYFRA1 :
                       wstawlabel(hwnd,'1');
                       return 0 ;
                     case IDM_CYFRA2 :
                       wstawlabel(hwnd,'2');
                       return 0 ;
                    case IDM_CYFRA3 :
                       wstawlabel(hwnd,'3');
                       return 0 ;
                    case IDM_CYFRA4 :
                       wstawlabel(hwnd,'4');
                       return 0 ;
                    case IDM_CYFRA5 :
                       wstawlabel(hwnd,'5');
                       return 0 ;
                    case IDM_CYFRA6 :
                       wstawlabel(hwnd,'6');
                       return 0 ;
                    case IDM_CYFRA7 :
                       wstawlabel(hwnd,'7');
                       return 0 ;
                    case IDM_CYFRA8 :
                       wstawlabel(hwnd,'8');
                       return 0 ;
                    case IDM_CYFRA9 :
                       wstawlabel(hwnd,'9');
                       return 0 ;
                    }
                 break ;

           
          case WM_PAINT :
                hdc = BeginPaint (hwnd, &ps) ;
             
                GetClientRect(hwnd,&rect);
                FillRect(hdc,&rect,hBrushLabel);
               // SetBkMode(hdc, TRANSPARENT);
                SetBkColor(hdc,labeltlo);
    nap = 'a';            
    for (y=1 ; y < 10; y++){
     for (x=1 ; x<10; x++){
       if (tablabel[x][y] == hwnd)
       {
         nap = naplabel[x][y];           
         break;
        } 
      }
     }              
                DrawText(hdc,&nap,1,&rect,DT_SINGLELINE | DT_CENTER | DT_VCENTER);
                
                 EndPaint (hwnd, &ps) ;
               return 0 ;


          }
	 return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

     }


 //------------------------------------------
void posprzatajLabel(void)
{
 if (hBrushLabel != 0) DeleteObject(hBrushLabel);


}  

 //------------------------------------------
void wstawlabel(HWND hwnd,char w)
{
 int x,y,a;
   RECT         rect;
char  buf[30];
   
   dodajHistoria(hwnd,0,0,w);   
  
    for (y=1 ; y < 10; y++){
     for (x=1 ; x<10; x++){
       if (tablabel[x][y] == hwnd)
       {
          naplabel[x][y] = w;           
          break;
        } 
      }
     }
    GetClientRect(hwnd,&rect);
    InvalidateRect(hwnd,&rect,TRUE);   //namaluj od nowa okienko
    
    if ( sprawdzpola() == 1) 
    {
      wsprintf (buf, "Koniec !!!\n%s",napZegar) ;
      MessageBox(hwndokno,buf,"wynik",MB_OK);

    }
}      
//-----------------------------------
void odblokujMenu(void){
 EnableMenuItem(hMenuLabel,IDM_CYFRA0,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA1,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA2,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA3,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA4,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA5,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA6,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA7,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA8,MF_ENABLED);
 EnableMenuItem(hMenuLabel,IDM_CYFRA9,MF_ENABLED);
 }
 //-----------------------------------
 void menudisable(char z)
 {
    switch (z) 
     {
      case '1' :EnableMenuItem(hMenuLabel,IDM_CYFRA1,MF_GRAYED);return ;
      case '2' :EnableMenuItem(hMenuLabel,IDM_CYFRA2,MF_GRAYED);return ;
      case '3' :EnableMenuItem(hMenuLabel,IDM_CYFRA3,MF_GRAYED);return ;
      case '4' :EnableMenuItem(hMenuLabel,IDM_CYFRA4,MF_GRAYED);return ;
      case '5' :EnableMenuItem(hMenuLabel,IDM_CYFRA5,MF_GRAYED);return ;
      case '6' :EnableMenuItem(hMenuLabel,IDM_CYFRA6,MF_GRAYED);return ;
      case '7' :EnableMenuItem(hMenuLabel,IDM_CYFRA7,MF_GRAYED);return ;
      case '8' :EnableMenuItem(hMenuLabel,IDM_CYFRA8,MF_GRAYED);return ;
      case '9' :EnableMenuItem(hMenuLabel,IDM_CYFRA9,MF_GRAYED);return ;
     } 
 }
 //-----------------------------------
 int okreslprzedzial(int c)
 {
  int w;
  
     switch (c)
     {
     case 1 :
     case 2 :
     case 3 : 
             w=1;
             break;
     case 4 :
     case 5 :
     case 6 : 
             w=4;
             break;
     case 7 :
     case 8 :
     case 9 : 
             w=7;
             break;
     }
             
  return w;
}
 
 //-----------------------------------
 void menuzablokuj(int x1,int y1)
 {
  int x,y;
  int a,b;
  
   for (y=1 ; y < 10; y++){
       menudisable(naplabel[x1][y]);
   }
    for (x=1 ; x < 10; x++){
      menudisable(naplabel[x][y1]);
   }
   a = okreslprzedzial(x1);
   b = okreslprzedzial(y1);
   
     for (y=b ; y < (b+3); y++){
       for (x=a ; x< (a+3); x++){
        menudisable(naplabel[x][y]);
       }
      } 
 
 }
 //-------------------------
void wybierzkolor(HWND hwnd)
{

 if (PopColorDlg (hwnd,labeltlo))
 {
  zmienkolorlabel(cc.rgbResult);
 }
 

}
//-------------------------
void zmienkolorlabel(COLORREF col)
{
 int x,y;
   RECT         rect;

  labeltlo = col;
  if (hBrushLabel != 0) DeleteObject(hBrushLabel);
  hBrushLabel = CreateSolidBrush(labeltlo);
    for (y=1 ; y < 10; y++){
     for (x=1 ; x<10; x++){
      
       GetClientRect(tablabel[x][y],&rect);
       InvalidateRect(tablabel[x][y],&rect,TRUE);   //namaluj od nowa okienko
      }
     }

}

