/***************************************************************************
 *     copyright            : (C) 2005 by Roman Szymkowiak                 *  
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <windows.h>
#include <winbase.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "mojedit.h"
#include "main.h"

HWND hzegar; 
char *napZegar;

DWORD czasZegar =0;

#define ID_TIMER    1

void zerujZegar(void);

DWORD pobierzZegar(void)
{
 DWORD t;
  struct _SYSTEMTIME cz;
  GetSystemTime(&cz);
  t = (cz.wHour * 3600) + (cz.wMinute * 60) + cz.wSecond; 
  return t;      
}  

 //------------------------------------------

void CALLBACK ProcedureTimer(HWND hwnd, UINT message, UINT iTimerID, DWORD dwTime)
{
 char buf[20];
 RECT         rect;
 DWORD t1,t2;
 int g,m,s;
 
  
 t1 = pobierzZegar(); 
  
 if (t1 >= czasZegar)
 {  
   t2= t1 - czasZegar; 
 }
 else
 {
  t2 = t1 + ((24 * 3600) - czasZegar);
 
 }
 
 g = (int)t2 /3600;
 m = (int)(t2 - (g *3600)) /60;
 s = (int)(t2 - (g *3600)) % 60;
  
  wsprintf(buf,"%02d:%02d:%02d",g,m,s);
  strncpy(napZegar,buf,10);
  napZegar[10]='\0';
  
  GetClientRect(hzegar,&rect);
  InvalidateRect(hzegar,&rect,TRUE); 
  
}
//--------------------------------
 void initZegar(void)
 {
 
  
   EnableWindow(hzegar,FALSE);
   napZegar = znajdzNapis(hzegar);

 //  strncpy(napZegar,"10:34:12",10);

   if (!SetTimer(hwndokno,ID_TIMER,1000,(TIMERPROC) ProcedureTimer))
   {
    MessageBox(hwndokno,"brak zegarw","komunikat",MB_OK);
   }
   zerujZegar();




}
 //------------------------------------------
void posprzatajZegar(void)
{
  KillTimer(hwndokno,ID_TIMER);     
}  

 //------------------------------------------
void zerujZegar(void)
{
  czasZegar = pobierzZegar();     
}  

 //------------------------------------------

